package swingxws;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import org.jdesktop.http.Method;
import org.jdesktop.http.async.XmlHttpRequest;
import org.jdesktop.http.async.AsyncHttpRequest;

//2-DO: bergeben einer Callback-Funktion ermglichen --> generisch 

public class AsyncReq extends AsyncHttpRequest{
	
	public AsyncReq (String url, Main cf){
	
            this.addReadyStateChangeListener( generateCallbackFunction(this,cf) );

            try {
                this.open(Method.GET, url, true);
                this.send();
             } catch (Exception e) {e.printStackTrace(); }	
	}
	

	public PropertyChangeListener generateCallbackFunction(AsyncReq as, Main cf){
		
            final AsyncReq req = as;
            final Main cookieFrame=cf;
            return  new PropertyChangeListener() {
                public void propertyChange(PropertyChangeEvent evt) {
                    if (evt.getNewValue() == ReadyState.LOADED) {
                    String response = req.getResponseText();
                    cookieFrame.setTextBereich(response);
                    }
                }
            };
        }
/*	
public static void main(String[] args) {
		
		System.out.println("Test ---- vor absenden des requests");
		new AsyncReq("http://www.ajax-buch.de/code/WS/getFortuneCookieWS/");
		System.out.println("Test ---- nach absenden des requests");
		
	}
	
	*/	
}
 
